/*
 *File name: pic2root.c
 * This little program takes the image given by the first argument, scales it,
 * and draws it onto the root window as a wallpaper.
 * 
 * (c) Copyright 2010  Oliver Schweisfurth
 */

#include <stdio.h>
#include <gtk/gtk.h>	
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <iostream>
#include <string.h>
using namespace std;

gint main(gint argc, gchar *argv[])
{
GdkWindow *root;
GdkPixbuf *pixbuf;
GdkPixmap *pixmap, *mask;

gtk_init(&argc, &argv); //gdk_init(&argc, &argv);

	GdkScreen *screen = gdk_screen_get_default();
	gint xres = gdk_screen_get_width(screen);
	gint yres = gdk_screen_get_height(screen);
	
if (strcmp(argv[1],"-h") == 0)
{
	cout << "usage:\npic2root /path/to/imagefile" << endl;
}

if (!(root = gdk_get_default_root_window()))
{
printf("Oops, window's broken \n");
return 1;
}

if (!(pixbuf = gdk_pixbuf_new_from_file(argv[1], NULL)))
{
	if (strcmp(argv[1],"-h") != 0)
	{
		printf("Couldn' load image %s!\n", argv[1]);
	}
return 1;
}

GdkPixbuf *pixbuf2 = gdk_pixbuf_scale_simple (pixbuf, xres, yres, GDK_INTERP_BILINEAR);
gdk_pixbuf_render_pixmap_and_mask(pixbuf2, &pixmap, &mask, 0);

if (!pixmap)
{
printf("Failed to create a pixmap!\n");
return 1;
}

gdk_window_set_back_pixmap(root, pixmap, FALSE);
gdk_window_show(root);
gdk_window_clear(root);

gtk_main(); //Da muss es noch was anderes geben für GDK?
return 0;
}
